package code;

import java.util.Date;
import java.util.Iterator;

import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

public class Luci {

	public ArrayList<Automa> Luci;//per ogni luce ho uno stato
	
	private static String brokerUrl;
	//private String learnTrigger;
	//private String attivaScenari;
	
	private JSONObject jsonObject;
	private final static String DATABASE_PATH = "./Luci.json";
	
	private static ArrayList<String> topicsSub;
	private String clientId = Long.toString(new Date().getTime()) + "-luci"; // unique client id
	//private Automa automa;
	private String mqttDomain;
	private String mqttSubdomain;
	private static String mqttTree;
	
	public static final String RES_FOLDER = "../res/";
	public static final String CONF_FOLDER = RES_FOLDER+"CONF/";
	private final static String FILE_CONF = CONF_FOLDER+"conf.json";//"./CONF/conf.json";
	//private final static String FILE_ZONA = CONF_FOLDER+"zona.json";//"./CONF/zona.json"
	private final static String FILE_ZONA = "CONF/zona.json";//"./CONF/zona.json"
	
	public MqttClient mqttClient;
	
	
	
	
	public Luci() throws JSONException, IOException, MqttException {
		
		JSONObject config = new JSONObject(Helper.leggiFile(FILE_CONF));
		brokerUrl = config.getString("protocol") + "://" + config.getString("broker") + ":" + config.getInt("port");
		mqttDomain = config.getString("mqttDomain");
		mqttSubdomain = config.getString("mqttSubdomain");
		makeMqttTree();
		
		topicsSub = new ArrayList<String>();
		topicsSub.add("to/all"); //mandare la mia descrizione json
		topicsSub.add(getMqttTree("rpc/","luci")); //mandare lo stato attuale
		
		// inutile aggiungere i topic, perche subbo gia' tutto gpio/#
		config = new JSONObject(Helper.leggiFile(FILE_ZONA));
		//learnTrigger = config.getString("learn-trigger");
//		topicsSub.add("from/"+Scenari.getMqttTree()+"gpio/" + learnTrigger); // Sottoscrivo i messaggi che notificano il cambiamento di stato dell'interruttore
		//attivaScenari = config.getString("attiva-scenari");
//		topicsSub.add("from/"+Scenari.getMqttTree()+"gpio/"+attivaScenari);
		
		
//		interruttoreOutputSuono = config.getString("outputSuono");
//		topicsSub.add("from/"+Scenari.getMqttTree()+"gpio/" + interruttoreOutputSuono); // Sottoscrivo i messaggi che notificano il cambiamento di stato dell'interruttore
//		topicsSub.add("to/"+Scenari.getMqttTree()+"scenari/learn");
		topicsSub.add(getMqttTree("from/","gpio/#"));
		topicsSub.add(getMqttTree("to/","luci/#"));//{"evento":0,"nome":nome_scenario} per attivare/disattivare uno scenario; risposta su from/tree/scenari/attiva con {"nome":nome_scenario}
		//topicsSub.add(getMqttTree("to/","luci/salva"));//per rinominare lo scenario piu recente
		
		this.mqttClient = new MqttClient(brokerUrl, clientId, new MemoryPersistence());
		//memory persistence serve per non avere errori in console
		// https://github.com/eclipse/paho.mqtt.java/issues/794
		
	}
	
	
	
	
	private void makeMqttTree() {
		if(mqttTree != null)
			return;
		mqttTree = mqttDomain + "/" + mqttSubdomain + "/";
	}
	
	public static String getMqttTree(String prefix,String suffix) {
		return (prefix.endsWith("/") ? prefix : prefix+"/") + mqttTree + (suffix.startsWith("/") ? suffix.substring(1) : suffix);
	}
	
	public static void main(String args[]) throws JSONException, IOException, MqttException {
		System.out.println("started");
		//PER TESTARE PRIMA TOGLI IL TRY CATCH !!!!! POI QUANDO TUTTO FUNZIONA, METTI IL TRY CATCH, togli le throws E IMPLEMENTA LA RIPARTENZA!
		
//		while(true) {
//			try {
		startSystemo();
//			}
//			catch(Exception e) {
//				// DA FARE:
//				// qui metto il codice per far ripartire il processo: rileggo lo stato dei sensori e dell'interruttore, 
//				// capisco di conseguenza in quale stato dell'automa mi trovo e riparto.
//				startSystem();
//			}
//		}
//		Scenari antifurto = 
//		new Scenari(new Automa());
	}
	
	
	private static void startSystemo() throws JSONException, IOException, MqttException {
		
//		MyQueue<Integer> codaVal = new MyQueue<Integer>();
//		MyQueue<Pair> codaMsg = ;
		JSONObject config = new JSONObject(Helper.leggiFile(FILE_ZONA));
		System.out.println(config);
		
		//conto quante lampadine
		Iterator<String> keys = config.keys();
		int countI=0;
		int countO=0;
		while(keys.hasNext()) {
		    String key = keys.next();
		    if (config.get(key) instanceof String) {
		           System.out.println(config.get(key));
		           if(config.get(key).toString().contains("OUT")) countO++;
		           if(config.get(key).toString().contains("IN")) countI++;
		    }
		}
		System.out.println(countI);
		System.out.println(countO);
		
		
		
		ArrayList<Automa> automa = new ArrayList<Automa>();
		//Luci luci = new Luci(automa);
//		Publisher publisher = new Publisher(new MyQueue<Pair>(), scenari);
//		Esecutore esec = new Esecutore(publisher, codaVal, automa, antifurto.interruttoreOutputSuono);
		//Esecutore esec = new Esecutore(/*publisher,*/automa,scenari);
//		Timer timer = new Timer(30000,-5,esec,automa);
		
		//luci.startClient(esec/*,publisher*/);//, publisher);
//		publisher.start();
		//esec.start();
//		timer.start();
	}
	
	/*
	
	private int setAutomi() throws JSONException, IOException {
	jsonObject = new JSONObject(Helper.leggiFile(DATABASE_PATH));
	setCollaterals(this.jsonObject.getInt("stato-attuale"));
	}
	
	private synchronized void setCollaterals(int stato,boolean write) {
		switch (stato) {
			case 0: {
				this.stato = false;
				
				
				break;
			}
			case 1: {
				this.stato = true;
				
				break;
			}
		}
		unreadStatus = true;
//		notifyAll();
		if(write)
			writeStatoOnDatabase();
	}
	*/
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
